---
title: Set a breakpoint
slug: Tools/Debugger/How_to/Set_a_breakpoint
tags:
  - JavaScript
  - Tools
  - breakpoint
  - column breakpoint
  - conditional breakpoint
---
<div>{{ToolsSidebar}}</div>

<p>There are many different types of breakpoint that can be set in the debugger; this article covers standard (unconditional) breakpoints and conditional breakpoints.</p>

<h2 id="Breakpoints_in_brief">Breakpoints in brief</h2>

<p>Breakpoints are very useful when debugging JavaScript — you basically set a point in your code where you would like execution of the code to pause. At this point you can do useful things like studying the value of different variables at that point, allowing you to work out why a problem is occurring.</p>

<h2 id="The_source_pane_context_menu">The source pane context menu</h2>

<p>In the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a>, you can handle setting breakpoints by bringing up the context menu over a line number.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16972/add-breakpoint-context.png" style="border-style: solid; border-width: 1px; height: 501px; width: 900px;"></p>

<p>There are a few options available here:</p>

<ul>
 <li><em>Add breakpoint</em>: Add a standard <strong>unconditional breakpoint</strong> at this line number (see below).</li>
 <li><em>Add condition</em>: Add a condition and create a <strong>conditional breakpoint</strong> (see below).</li>
 <li><em>Add log</em>: Add a <strong><a href="/en-US/docs/Tools/Debugger/Set_a_logpoint">log point</a></strong>, which logs a value to your console rather than pausing execution as a breakpoint does.</li>
 <li><em>Continue to here</em>: When <a href="/en-US/docs/Tools/Debugger/How_to/Step_through_code">stepping through code</a>, this option tells the debugging to continue execution through to this point.</li>
</ul>

<h2 id="Unconditional_breakpoints">Unconditional breakpoints</h2>

<p>An unconditional breakpoint is one where the code will always pause execution when it is reached. You can set an unconditional breakpoint using the context menu (see above), or by:</p>

<ul>
 <li>Clicking on the line number for the line you want to break at in the source pane.</li>
 <li>Highlighting the line you want to break at in the source pane and pressing <kbd>Ctrl</kbd> + <kbd>B</kbd> (Windows/Linux) or <kbd>Cmd</kbd> + <kbd>B</kbd> (macOS).</li>
</ul>

<p>The line number is highlighted in blue:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16974/breakpoints-on-line.png" style="border-style: solid; border-width: 1px; height: 86px; width: 750px;"></p>

<p>In addition, if the line contains multiple function calls, each one will be given a small blue arrow icon to the left of it. These are called <strong>column breakpoints</strong>, and allow you to set the breakpoint to happen exactly on any one of the function calls in the line (or multiple calls), by clicking on each relevant one.</p>

<h2 id="Conditional_breakpoints">Conditional breakpoints</h2>

<p>A conditional breakpoint is one where the code will pause execution when it is reached, only if a certain condition is met, such a variable having a certain value at the time. You can set a conditional breakpoint using the context menu (see above), or by highlighting the line you want to break at in the source pane and pressing <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>B</kbd> (Windows/Linux) or <kbd>Cmd</kbd> + <kbd>Shift</kbd> + <kbd>B</kbd> (macOS).</p>

<p>When you first choose to set a conditional breakpoint, a text entry line will appear into which you add the condition you want it to break on:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/17396/updated-conditional.png" style="border-style: solid; border-width: 1px; height: 501px; width: 900px;"></p>

<p>Once you've entered your condition and pressed <kbd>Enter</kbd>/<kbd>Return</kbd>, the line number will be highlighted in orange:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16975/conditional-set.png" style="border-style: solid; border-width: 1px; height: 500px; width: 900px;"></p>

<h2 id="Breakpoints_list">Breakpoints list</h2>

<p>Once you've set some breakpoints, the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Breakpoints_list">breakpoints list</a> in the right-hand column shows the filename and line number for each one:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16973/breakpoints-list.png" style="border: 1px solid black; display: block; height: 190px; margin: 0px auto; width: 500px;"></p>

<h2 id="Unsetting_a_breakpoint">Unsetting a breakpoint</h2>

<p>Once a breakpoint has been set, you can unset it again in various ways:</p>

<ul>
 <li>Click on the line number highlight.</li>
 <li>Highlight the line of code the breakpoint is set on and pressing <kbd>Ctrl</kbd> + <kbd>B</kbd> (Windows/Linux) or <kbd>Cmd</kbd> + <kbd>B</kbd> (macOS).</li>
 <li>Bring up the context menu over the line highlight and choose the <em>Remove Breakpoint</em> option.</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/16977/remove-breakpoint-context.png" style="border-style: solid; border-width: 1px;"></p>

<p>Other context menu options worth mentioning are:</p>

<ul>
 <li><em>Disable Breakpoint:</em> turn it off, but don't remove it completely.</li>
 <li><em>Disable breakpoints on line</em> and <em>Remove breakpoints on line</em>: Remove or disable column breakpoints.</li>
 <li>If the breakpoint is an unconditional breakpoint, you'll get an option <em>Add condition</em>, which allows you to turn it into a conditional breakpoint.</li>
 <li>If the breakpoint is a conditional breakpoint, you'll get an option <em>Edit condition</em>, which allows you to change the previously set condition.</li>
</ul>

<h2 id="Inline_variable_preview">Inline variable preview</h2>

<p>New in Firefox 71, the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a> now gives you an inline preview of the variables on each line of code you've stepped through:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16976/inline-variables.png" style="border-style: solid; border-width: 1px; height: 172px; width: 800px;"></p>

<p>This is a very useful timesaver when stepping through your code. Previously you’d have to scroll through the Scopes panel to find variable values, or hover over a variable in the source pane. Now when execution pauses, you can view relevant variables immediately.</p>

<div class="notecard note">
<p><strong>Note</strong>: There is also a new option in the context menu for the actual code in the source pane — <em>Hide inline preview</em>/<em>Show inline preview</em> — which allows you to turn the inline variables on/off.</p>
</div>
